"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Function = exports.Functions = void 0;
class Function {
    constructor(properties) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7;
        this.FunctionName = (_a = properties.FunctionName) !== null && _a !== void 0 ? _a : null;
        this.FunctionArn = (_b = properties.FunctionArn) !== null && _b !== void 0 ? _b : null;
        this.Runtime = (_c = properties.Runtime) !== null && _c !== void 0 ? _c : null;
        this.Role = (_d = properties.Role) !== null && _d !== void 0 ? _d : null;
        this.Handler = (_e = properties.Handler) !== null && _e !== void 0 ? _e : null;
        this.CodeSize = (_f = properties.CodeSize) !== null && _f !== void 0 ? _f : null;
        this.Description = (_g = properties.Description) !== null && _g !== void 0 ? _g : null;
        this.Timeout = (_h = properties.Timeout) !== null && _h !== void 0 ? _h : null;
        this.MemorySize = (_j = properties.MemorySize) !== null && _j !== void 0 ? _j : null;
        this.LastModified = (_k = properties.LastModified) !== null && _k !== void 0 ? _k : null;
        this.CodeSha256 = (_l = properties.CodeSha256) !== null && _l !== void 0 ? _l : null;
        this.Version = (_m = properties.Version) !== null && _m !== void 0 ? _m : null;
        this.VpcConfig = (_o = properties.VpcConfig) !== null && _o !== void 0 ? _o : null;
        this.DeadLetterConfig = (_p = properties.DeadLetterConfig) !== null && _p !== void 0 ? _p : null;
        this.Environment = (_q = properties.Environment) !== null && _q !== void 0 ? _q : null;
        this.KMSKeyArn = (_r = properties.KMSKeyArn) !== null && _r !== void 0 ? _r : null;
        this.TracingConfig = (_s = properties.TracingConfig) !== null && _s !== void 0 ? _s : null;
        this.MasterArn = (_t = properties.MasterArn) !== null && _t !== void 0 ? _t : null;
        this.RevisionId = (_u = properties.RevisionId) !== null && _u !== void 0 ? _u : null;
        this.Layers = (_v = properties.Layers) !== null && _v !== void 0 ? _v : null;
        this.State = (_w = properties.State) !== null && _w !== void 0 ? _w : null;
        this.StateReason = (_x = properties.StateReason) !== null && _x !== void 0 ? _x : null;
        this.StateReasonCode = (_y = properties.StateReasonCode) !== null && _y !== void 0 ? _y : null;
        this.LastUpdateStatus = (_z = properties.LastUpdateStatus) !== null && _z !== void 0 ? _z : null;
        this.LastUpdateStatusReason = (_0 = properties.LastUpdateStatusReason) !== null && _0 !== void 0 ? _0 : null;
        this.LastUpdateStatusReasonCode = (_1 = properties.LastUpdateStatusReasonCode) !== null && _1 !== void 0 ? _1 : null;
        this.FileSystemConfigs = (_2 = properties.FileSystemConfigs) !== null && _2 !== void 0 ? _2 : null;
        this.PackageType = (_3 = properties.PackageType) !== null && _3 !== void 0 ? _3 : null;
        this.ImageConfigResponse = (_4 = properties.ImageConfigResponse) !== null && _4 !== void 0 ? _4 : null;
        this.SigningProfileVersionArn = (_5 = properties.SigningProfileVersionArn) !== null && _5 !== void 0 ? _5 : null;
        this.SigningJobArn = (_6 = properties.SigningJobArn) !== null && _6 !== void 0 ? _6 : null;
        this.Architectures = (_7 = properties.Architectures) !== null && _7 !== void 0 ? _7 : null;
    }
}
exports.Function = Function;
class Functions extends Array {
    constructor(response) {
        super();
        (response) && response.forEach(($) => {
            this.push(new Function(Object.assign({}, $)));
        });
    }
    serialize(pretty) {
        return JSON.stringify(this, null, (pretty) ? 4 : undefined);
    }
}
exports.Functions = Functions;
exports.default = { Functions, Function };
