const Awaitable = async ( duration: number, context: string, debug: boolean = false) => {
    const count = Reflect.get( Awaitable, "count" );
    return new Promise( async ( resolve ) => {
        (debug) && console.debug( "[Debug] Mutex Lock" + " " + "[" + context + "]" + " " + "(" + count + ")" );
        (debug) && Reflect.set( Awaitable, "count", count + 1 );

        // @ts-ignore
        await setTimeout[Object.getOwnPropertySymbols( setTimeout )[0]]( duration );

        resolve( true );
    } );
};

Reflect.set( Awaitable, "count", 0 );

export { Awaitable };
export default { Awaitable };
