#!/usr/bin/env node

import * as Lambda from "./src";

/// index.ts
void ( async () => import("./src").then( async ( Package /*** @type {Lambda}  */ ) => {
    const output: {[$: string]: string} = {};

    const service = new Package.Service();
    const functions: Lambda.Data = await service.functions(false);

    functions.forEach(($) => {
        output[$.FunctionName as string] = JSON.stringify($, null, 4);
    });

    process.stdout.write(JSON.stringify(output, null, 4));
} ) )();
