"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Awaitable = void 0;
const Awaitable = (duration, context, debug = false) => __awaiter(void 0, void 0, void 0, function* () {
    const count = Reflect.get(Awaitable, "count");
    return new Promise((resolve) => __awaiter(void 0, void 0, void 0, function* () {
        (debug) && console.debug("[Debug] Mutex Lock" + " " + "[" + context + "]" + " " + "(" + count + ")");
        (debug) && Reflect.set(Awaitable, "count", count + 1);
        // @ts-ignore
        yield setTimeout[Object.getOwnPropertySymbols(setTimeout)[0]](duration);
        resolve(true);
    }));
});
exports.Awaitable = Awaitable;
Reflect.set(Awaitable, "count", 0);
exports.default = { Awaitable };
